--LuaMarquee v5.7 by Smurfier (smurfier20@gmail.com)
--This work is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 3.0 License.

PROPERTIES =
{
Text='';
MeasureName='';
Variable='';
Width=10;
Delimiter='  ';
ForceScroll=0;
}

function Initialize()
   ms={}
   for w in string.gmatch(PROPERTIES.MeasureName,'[^%|]+') do table.insert(ms,SKIN:GetMeasure(w)) end
   OldText,Width,Timer,Pause='',tonumber(PROPERTIES.Width),0,1
end -- function Initialize

function Update()
   local Values={}
   for i,v in ipairs(ms) do table.insert(Values,v:GetStringValue()) end
   for w in string.gmatch(PROPERTIES.Variable,'[^%|]+') do table.insert(Values,SKIN:GetVariable(w)) end
   if PROPERTIES.Text~='' then table.insert(Values,PROPERTIES.Text) end
   Text=string.gsub(#Values>0 and table.concat(Values,PROPERTIES.Delimiter) or 'Input Error!','\n',' ')
   if Text~=OldText then Timer,Length,OldText=0,string.len(Text),Text end
   Timer=Timer%(Length+Width)+((Length<=Width and PROPERTIES.ForceScroll==0) and 0 or 1)*Pause
   return string.sub(string.rep(' ',(Length<=Width and PROPERTIES.ForceScroll==0) and 0 or Width)..Text,Timer,Timer+Width)
end -- function Update